/*
ESP32 XBEE sketch v1.3 2021/10/19

www.printed-droid.com

This sketch makes it possible to use an esp32 instead of the xbee.

Use is at your own risk and without further support.

Please test the range and reliability before use.

More information is available at: https://www.printed-droid.com/kb/esp-as-xbee-replacement/

Change the SSID and password in the sketch!!!
The ESP IP is visible via the Arduino IDE serial monitor (mostly 192.168.4.1) 

Then the ESP is connected to the Astrocomms, Benduino or Marcduino like the XBEE. 
5V
GND
RX to TX
TX to RX 
*/

#include <WiFi.h>

const char* ssid = "R2D2 ESP32"; //name of the wifi-network created by the ESP32
const char* pass = "123456789"; //replace with a more secure password!

// Set web server port number to 9750
WiFiServer server(9750);

bool connected = false;
WiFiClient client;


void setup() {
  Serial.begin(9600);
 Serial.println("Astromech ready");

  WiFi.softAP(ssid, pass);
  IPAddress IP = WiFi.softAPIP();
  Serial.print("AP IP address: ");
  Serial.println(IP);
  server.begin();
}

void loop() {
  // put your main code here, to run repeatedly:
  if(!connected) {
    client = server.available();
  }
  
  if(client.connected()) {
    if(!connected) {
      Serial.println("TCP connected");
      connected = true;
    }
    
    while(client.connected()) {
      while(client.available() > 0) {
        char c = client.read();
        Serial.write(c);
      }
    }
  } else {
    if(connected) {
      Serial.println("TCP disconnected");
      connected = false;
    }
  }
}
